#############################################################################
# Author        : Ruediger Arnold
# Date          : 03.09.2012 
# Description   : Save all tree data into the result directory
# Category      : Parser
#############################################################################
#               : 
#               : initial
#               :
##############################################################################

use strict;

###################################
# main routine
###################################
if ($#ARGV == 1) {
	&saveTree($ARGV[0],$ARGV[1]);
	exit;
	}	
else {
	print "*****************************\n";
	print "usage: $0 <data_file_position> <name_of_tree> \n";
	print "*****************************\n";
	exit;
}		

###################################
# subroutines
###################################
sub saveTree {


	my $fnDataFilePosition = shift;
	my $treeName = shift;
	my $inr;
	my $gen;
	my $line;

	if ( $^O eq "MSWin32") {  # Window Operating System
		print "Window Operating System 1\n";
		# Make Result Directory
		system("echo *");
		system("echo * Copy Tree Files into the Directory:");
		system("echo * \%\$resultDir\%\\".$treeName);
		system("echo *");
		system("mkdir \%\$resultDir\%\\".$treeName);
		# system("mkdir \%\$resultDir\%\\".$treeName."\\oo_draw");
		# system("mkdir \%\$resultDir\%\\".$treeName."\\oo_svm");
		system("mkdir \%\$resultDir\%\\".$treeName."\\BaumDefinitionen");
		# system("mkdir \%\$resultDir\%\\".$treeName."\\BaumDaten");
	
		# Copy General Files
		#system("copy \%\$treeTempDir\%\\example_marriage.odg \%\$resultDir\%\\".$treeName."\\oo_draw");
		#system("copy \%\$svmDir\%\\example_marriage.odg.svm \%\$resultDir\%\\".$treeName."\\oo_svm");
		#system("copy \%\$treeTempDir\%\\example_further.odg \%\$resultDir\%\\".$treeName."\\oo_draw");
		#system("copy \%\$svmDir\%\\example_further.odg.svm \%\$resultDir\%\\".$treeName."\\oo_svm");
		system("copy \%\$treeDefDir\%\\tree_form.txt \%\$resultDir\%\\".$treeName."\\BaumDefinitionen");
		system("copy \%\$treeDefDir\%\\tree_scaling.txt \%\$resultDir\%\\".$treeName."\\BaumDefinitionen");
		system("copy \%\$treeDefDir\%\\persons_in_tree.txt \%\$resultDir\%\\".$treeName."\\BaumDefinitionen");
		
		system("copy \%\$treeDir\%\\tree.odg \%\$resultDir\%\\".$treeName."\\tree_".$treeName."\.odg");
		#system("copy \%\$treeDataDir\%\\data_file_row_placement.csv \%\$resultDir\%\\".$treeName."\\BaumDaten");
	} else {
		print "Linux Cygwin or MAC Operating System 1\n";
		# Make Result Directory
		system("echo \"*\"");
		system("echo \"* Copy Tree Files into the Directory:\"");
		system("echo \"*\" \$resultDir\/".$treeName);
		system("echo \"*\"");
		system("mkdir \$resultDir\/".$treeName);
		#system("mkdir \$resultDir\/".$treeName."\/oo_draw");
		#system("mkdir \$resultDir\/".$treeName."\/oo_svm");
		system("mkdir \$resultDir\/".$treeName."\/BaumDefinitionen");
		#system("mkdir \$resultDir\/".$treeName."\/BaumDaten");
	
		# Copy General Files
		#system("cp \$treeTempDir\/example_marriage.odg \$resultDir\/".$treeName."\/oo_draw");
		#system("cp \$svmDir\/example_marriage.odg.svm \$resultDir\/".$treeName."\/oo_svm");
		#system("cp \$treeTempDir\/example_further.odg \$resultDir\/".$treeName."\/oo_draw");
		#system("cp \$svmDir\/example_further.odg.svm \$resultDir\/".$treeName."\/oo_svm");
		system("cp \$treeDefDir\/tree_form.txt \$resultDir\/".$treeName."\/BaumDefinitionen");
		system("cp \$treeDefDir\/tree_scaling.txt \$resultDir\/".$treeName."\/BaumDefinitionen");
		system("cp \$treeDefDir\/persons_in_tree.txt \$resultDir\/".$treeName."\/BaumDefinitionen");
		
		system("cp \$treeDir\/tree.odg \$resultDir\/".$treeName."\/tree_".$treeName."\.odg");
		#system("cp \$treeDataDir\/data_file_row_placement.csv \$resultDir\/".$treeName."\/BaumDaten");
	}



	# Copy Used ODG and SVM files
	#open(IN, "<$fnDataFilePosition") || die "Can't open file $fnDataFilePosition ($!)\n";
	#while(<IN>) {			
	#	$line= $_;
	#	if ( $line =~ m/INR (\d*) GEN (.*?) DIST (\d*) UD (\d*) DU (\d*) SS (\d*) SIDE (-*\d*) PLC (\d*) A2P (\d*)/ ) {
	#		$inr = $1;
	#		$gen = $2;
	#	} else {
	#		print $line."\n";
	#		print "**** ERROR Wrong format in file ".$fnDataFilePosition."\n";
	#		exit;
	#	}
	#	if ($gen eq "not_in_tree") {
	#		print "  **** Person ".$inr." is not in the tree, no data copied.\n";
	#	} else {
	#		print "  **** Copy Files for Person ".$inr.".\n";
	#
	#        if ( $^O eq "MSWin32") {  # Window Operating System
       	#		print "Window Operating System 2\n";
	#		system("copy \%\$odgDir\%\\i".$inr.".odg \%\$resultDir\%\\".$treeName."\\oo_draw");
	#		system("copy \%\$svmDir\%\\i".$inr.".odg.svm \%\$resultDir\%\\".$treeName."\\oo_svm");
	#	} else {
	#		print "Linux Cygwin or MAC Operating System 2\n";
	#		system("cp \$odgDir\/i".$inr.".odg \$resultDir\/".$treeName."\/oo_draw");
	#		system("cp \$svmDir\/i".$inr.".odg.svm \$resultDir\/".$treeName."\/oo_svm");
	#	}
	#
	#	}
	#}
	#close(IN);

}
